\documentclass{IEEEconf}

\input{macros}

\author{Emmanuel Madrigal}

\title{Evaluation of feature descriptors and matching}

\begin{document}

\maketitle

\begin{abstract}
  This paper shows a experiments done on a camera calibration system. This shows
  that a large number of images is not needed for a calibration since the value stagnate at around 30 images, also the number of repetitions in the algorithm should alsoe be limited since at around 12 iterations the value reaches a minimum.
\end{abstract}

\section{Introduction}

\subsection{3D to 2D projection}

In homogeneous coordinates, the projection has a simple linear form,

\begin{equation}
  \hat{\mathbf{x}} =
  \left[
    \begin{matrix}
      1 & 0 & 0 & 0 \\
      0 & 1 & 0 & 0 \\
      0 & 0 & 1 & 0 \\
    \end{matrix}
  \right]
  \hat{p}
\end{equation}

where $\hat{\mathbf{p}}$ is the 3D point and $\mathbf{x}$ is the 2D point. 

The relationship~\cite{szeliski2010computer} between the 3D pixel center $\mathbf{p}$ and the 3D camera-centerd point $\mathbf{p}_c$ is given by an unknown scaling $s$, $\mathbf{p} = s\mathbf{p}_c$. We can write the complete projection between $\mathbf{p}_c$ and a homogeneous version of the pixel address $\hat{\mathbf{x}}_s$ as:

\begin{equation}
  \hat{\mathbf{x}}_s = K \mathbf{p}_c
\end{equation}

The $3 \times 3$ matrix $K$ is called the \textit{calibration matrix} and
describes the camera intrinsics. Whe ncalibration a camera based on external 3D ppoints or othe measurementsm, we end up estimating the intrising $\mathbf{K}$ and extrinsic $\mathbf{R}, \mathbf{t}$ camera parameters simultanesouly using a series of measurements:

\begin{equation}
  \hat{\mathbf{x}}_s = K \left[
    \begin{matrix}
      \mathbf{R} & \mathbf{t}
    \end{matrix}
  \right]
  \mathbf{p}_w
\end{equation}

Where $\mathbf{p}_w$ are known 3D world coorindates. There are several ways to write the upper triangular for mof $\mathbf{K}$ one possiblity is:

\begin{equation}
  \mathbf{K} =
  \left[
    \begin{matrix}
      f_x & s & c_x \\
      0 & f_y & c_y \\
      0 & 0 & 1
    \end{matrix}
  \right]
\end{equation}

\subsubsection{Lens distortions}

The imaging models assume that all cameras obey a linear projection model,
however may wide-angle lenses have noticeable radial distortion which manifests
itself as a visible curvature in the projection of straight lines. The simplest radial distortion models use low order polynomials:

\begin{equation}
  \begin{aligned}
    \hat{x}_c = x_c (1 + \kappa_1 r_c^2 + \kappa_2 r_c^4) \\
    \hat{y}_c = y_c (1 + \kappa_1 r_c^2 + \kappa_2 r_c^4)
  \end{aligned}
\end{equation}

Where $r_c^2 = x_c^2 + y_c^2$ and $\kappa_1$ and $\kappa_2$ are the radial distortion parameters.


\subsection{Reprojection error}

The reprojection error~\cite{andrew2001multiple} is a geometric error corresponding to the distance
between a projected point and measured one. This is used to quantify how closely
an estimate of a 3D point $\hat{\mathbf{X}}$ recreates the point's true
projection $\mathbf{x}$.

If $P$ is the projection matrix of a camera and
$\hat{\mathbf{x}}=P\hat{\mathbf{X}}$ the image projection of $\hat{\mathbf{X}}$,
the reprojection error is given by $d\left(\mathbf{x}, \hat{\mathbf{x}}\right)$
where $d(\cdot, \cdot)$ is the euclidian distance.

\subsection{3D point projection}

Relevant to this paper is the projection of the camera, once the chessboard
position has been fixed according to a virtual camera. Assume that the camera
calibration for a given pattern return the $\mathbf{R}_{pc}$ and
$\mathbf{t}_{pc}$ rotation and translation vector. The vectors for the camera
according to the pattern are given by:

\begin{equation}
  \begin{aligned}
    \mathbf{R}_{cp} = \mathbf{R}_{pc}^{-1} \\
    \mathbf{t}_{cp} = -\mathbf{t}_{pc}
  \end{aligned}
\end{equation}

Assume a given transformation for the pattern according to the virtual camera
$\mathbf{R}_{pv}$ and $\mathbf{t}_{pv}$. The tranformation of the camera according to the virtual camera is given by:

\begin{equation}
  \begin{aligned}
    \mathbf{R}_{cv} = \mathbf{R}_{cp} \mathbf{R}_{pv} = \mathbf{R}_{pc}^{-1} \mathbf{R}_{pv} \\
    \mathbf{t}_{cv} = \mathbf{t}_{pv} + \mathbf{R}_{pc}^{-1} \left(-\mathbf{t}_{pc}\right)
  \end{aligned}
\end{equation}

\section{Results}

\subsection{Camera calibration}

The camera calibration experiment uses 275 captured images as as input, and
evaluates the result according to two variables:
\begin{itemize}
  \item The number of iterations in the calibration algorithm.
  \item The number of images used.
\end{itemize}

In figure~\ref{fig:num_images} the results according to the number of images are
shown. The reprojection error quickly decreases until it reaches around 30
images, after which the value mostly stays the same. The large number of images
used are not necessary and since this images are randomly sampled there is a
large probability that even a lower number of images can reach an optimal value
if using a more directed approach to the images used for calibration.

\begin{figure}[htbp]
 \begin{tikzpicture}
 \begin{axis}[legend pos=outer north east, xmode=log, xlabel={Reprojection Error}, ylabel={Number of images}]
 \addplot table [x=Images, y=Reprojection_Error, col sep=comma] {data/number_of_images.csv};
 \end{axis}
 \end{tikzpicture}
 \caption{Reprojection error change based on the number of images}
 \label{fig:num_images}
\end{figure}

In figure~\ref{fig:repetitions} the reprojection error in function of the number
of repetitions used by the calibration algorithm are shown.  This value quickly
decreases, reaching a minimum at around 12 iterations. Further iterations do not
provide an improvements in the reprojection error. OpenCV's algorithm also
provides a stopping criteria related to the epsilon value, which stops after no improment is made which is the case in larger amounts of iterations.

\begin{figure}[htbp]
 \begin{tikzpicture}
 \begin{axis}[legend pos=outer north east, xlabel={Reprojection Error}, ylabel={Calibration repetitions}]
 \addplot table [x=Repetitions, y=Reprojection_Error, col sep=comma] {data/repetitions.csv};
 \end{axis}
 \end{tikzpicture}
 \caption{Reprojection error based on the number of repetitions}
 \label{fig:repetitions}
\end{figure}

\subsection{Virtual Reality projection}

In figure~\ref{fig:projected_pattern} examples of the projected pattern are
shown. These images show how the transformation is able to correctly represent
the distance in the $Z$ axis and and a rotation.

\begin{figure*}[ht]
  \begin{subfigure}{.4\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/close_frame.png}
    \caption{Pattern close to the camera}
  \end{subfigure}%
  \begin{subfigure}{.4\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/close_chessboard.png}
    \caption{Projected pattern close to the camera}
  \end{subfigure}

  \begin{subfigure}{.4\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/far_frame.png}
    \caption{Pattern far from the camera}
  \end{subfigure}%
  \begin{subfigure}{.4\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/far_chessboard.png}
    \caption{Projected pattern far from the camera}
  \end{subfigure}
   
  \begin{subfigure}{.4\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/rotated_frame.png}
    \caption{Rotated pattern relative to the camera}
  \end{subfigure}%
  \begin{subfigure}{.4\textwidth}
    \centering
    \includegraphics[width=\textwidth]{images/rotated_chessboard.png}
    \caption{Rotated projected camera relative to the pattern }
  \end{subfigure}
  \caption{Projected pattern example}
  \label{fig:projected_pattern}
\end{figure*}

\section{Conclusions}

 The reduction in the reprojection error for a calibration stagnates at around
 30 images. This value is also for randomly sampled images, if these images were
 taken in a more purposeful fashion this would further reduce the amount of
 values needed.

 The number of repetitions needed for the calibration algorithm have a
 significant reduction in the improvement on the reprojection error after 12
 iterations, another stopping criteria such as the epsilon value used by the
 OpenCV should also be used for this criteria.

\printbibliography

\newpage
\end{document}

